"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorHandler = void 0;
const errors_1 = require("@feathersjs/errors");
function errorHandler(error) {
    // NOTE (EK): The list of error code is way too massive to map
    // them to a specific error object so we'll use a generic one.
    // See https://github.com/mongodb/mongo/blob/master/docs/errors.md
    if (error.name === 'MongoError') {
        throw new errors_1.GeneralError(error, {
            ok: error.ok,
            code: error.code
        });
    }
    throw error;
}
exports.errorHandler = errorHandler;
;
//# sourceMappingURL=error-handler.js.map