import { ObjectId, Collection } from "mongodb";
import { AdapterService, InternalServiceMethods, AdapterParams } from "@feathersjs/adapter-commons";
import { NullableId, Id } from "@feathersjs/feathers";
export interface ServiceOptions {
    events?: string[];
    multi?: boolean | string[];
    id?: string;
    paginate?: {
        default?: number;
        max?: number;
    };
    whitelist?: string[];
    allow?: string[];
    filters?: string[];
}
declare type Nullable_Id = ObjectId | NullableId;
declare type _Id = ObjectId | Id;
interface AnyData {
    [key: string]: any;
}
export interface MongoServiceOptions extends ServiceOptions {
    Model?: Collection;
    useEstimatedDocumentCount?: Boolean;
}
export declare class Service<T = any, D = Partial<T>> extends AdapterService<T, D> implements InternalServiceMethods<T> {
    options: any;
    Model: any;
    constructor(options: MongoServiceOptions);
    _getModel(params?: AdapterParams): any;
    _objectifyId(id: _Id): _Id;
    _multiOptions(id: Nullable_Id, params?: AdapterParams): {
        query: any;
        options: any;
    };
    _options(params?: AdapterParams): {
        filters: any;
        query: any;
        paginate: any;
        options: any;
    };
    _getSelect(select: any): any;
    _findOrGet(id: Nullable_Id, params?: AdapterParams): any;
    _normalizeId(id: Nullable_Id, data: AnyData): AnyData;
    _remapModifiers(data: any): any;
    _find(params?: AdapterParams): any;
    _get(id: _Id, params?: {}): any;
    _create(data: AnyData, params?: AdapterParams): any;
    _patch(id: Nullable_Id, data: AnyData, params?: AdapterParams): any;
    _update(id: _Id, data: AnyData, params?: AdapterParams): any;
    _remove(id: Nullable_Id, params?: AdapterParams): any;
}
export declare function mongodb(options: MongoServiceOptions): Service<any, Partial<any>>;
export {};
